<?php
/**
 * Created by PhpStorm.
 * User: zhaofei
 * Date: 15/12/2
 * Time: 下午7:47
 */

if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

class WebHelper
{

    public static function getQuery()
    {

    }

    /**
     * 接收POST数据
     * @param $key
     * @param string $defaultValue
     * @return string
     */
    public static function getPost( $key, $defaultValue = '' )
    {
        global $_G;

        $value = Yii::app()->request->getPost( $key, $defaultValue );

        if( !defined( 'IN_MOBILE' ) && strtoupper( $_G['charset'] ) != 'UTF-8' )
        {
            $value = iconv( 'UTF-8', 'GBK//IGNORE', $value );
            //$value = iconv( 'UTF-8', 'GBK//IGNORE', $value );
        }

        return $value;
    }

    /**
     * 百度站内搜索
     *
     * @param $keyword
     * @param $page
     * @param string $srt  搜索结果排序，默认def  cse_createTime：发布时间  cse_category2：回复数
     * @param int $fst  搜索类型，0：帖子 1：板块 2：用户
     * @param int $stp 是否全文检索 0：全文 1：标题
     * @param int $nsid
     * @param int $nojc 是否模糊搜索，0:模糊搜索(例如keyword=qianfan，搜索为'千帆'的结果)，1:精确搜索
     * @return array
     */
    public static function zhanneiSearch($keyword, $page, $srt='def', $fst=0, $stp=1, $nsid=0, $nojc=1) {
        $data = array();
        if(empty(Yii::app()->params['search_id'])) return $data;
        $sid = Yii::app()->params['search_id'];

        $urlThread="http://zhannei.baidu.com/api/customsearch/searchwap?q=".urlencode($keyword)."&s=".$sid."&p=".$page."&srt=".$srt."&stp=".$stp."&fst=".$fst."&nsid=".$nsid."&nojc=".$nojc;

        $content = dfsockopen($urlThread, 0, '', '', FALSE, '', $time=5);
        $thread = CJSON::decode($content);
        if( !empty($thread['results']) ) {
            foreach($thread['results'] as $k => $v) {
                $res = array();
                if( $fst == 2 ) {
                    $data[] = preg_replace('/http.*uid=(\d+)/i', '${1}', $v['url']);
                }else{
                    $res['tid'] = self::getTidByThreadurl($v['url']);
                    $res['subject'] = $v['threadTitle'];
                    $res['author'] = $v['post_author'];
                    $res['postdate'] = $v['post_createdTime'];
                    $res['views'] = $v['viewCount'];
                    $res['numFound'] = $thread['numFound'];
                    $res['attachment'] = !empty($v['post_attachment_attachmentUrl']) ? 1 : 0;

                    $data[] = $res;
                    unset($res);
                }
            }
        }
        return $data;
    }

    /**
     * DB 检索帖子
     * @param $keyword
     * @param $page
     * @return int[]
     */
    public static function dbSearch($keyword, $page)
    {
        global $_G;

        loadcache('forums');

        // 获取搜索版块的ID
        $cache_fids = $comma = '';
        foreach ($_G['cache']['forums'] as $fid => $forum) {
            if ($forum['type'] != 'group' && (!$forum['viewperm'] && $_G['group']['readaccess']) || ($forum['viewperm'] && forumperm($forum['viewperm']))) {
                $cache_fids .= "$comma'$fid'";
                $comma = ',';
            }
        }
        $searchstring = 'forum|title|' . base64_encode($keyword) . '|0||' . addslashes($cache_fids) . '|0|0|all|||0';

        $searchindex = array('id' => 0, 'dateline' => '0');

        foreach (C::t('common_searchindex')->fetch_all_search($_G['setting']['search']['forum']['searchctrl'], $_G['clientip'], $_G['uid'], $_G['timestamp'], $searchstring, 2) as $index) {
            if ($index['indexvalid'] && $index['dateline'] > $searchindex['dateline']) {
                $searchindex = array('id' => $index['searchid'], 'dateline' => $index['dateline']);
                break;
            }
        }

        if ($searchindex['id']) {
            $searchid = $searchindex['id'];
        } else {
            $num = $ids = 0;
            $_G['setting']['search']['forum']['maxsearchresults'] = $_G['setting']['search']['forum']['maxsearchresults'] ? intval($_G['setting']['search']['forum']['maxsearchresults']) : 500;

            $sqlsrch = "FROM ".DB::table('forum_thread')." t WHERE t.fid IN ($cache_fids) AND t.displayorder>='0' AND t.subject LIKE '%$keyword%'";

            $query = DB::query("SELECT t.tid, t.closed, t.author, t.authorid $sqlsrch ORDER BY t.tid DESC LIMIT " . $_G['setting']['search']['forum']['maxsearchresults']);
            while ($thread = DB::fetch($query)) {
                $ids .= ',' . $thread['tid'];
                $num++;
            }
            DB::free_result($query);

            $searchid = C::t('common_searchindex')->insert(array(
                'srchmod' => 2,
                'keywords' => $keyword,
                'searchstring' => $searchstring,
                'useip' => $_G['clientip'],
                'uid' => $_G['uid'],
                'dateline' => $_G['timestamp'],
                'expiration' => TIMESTAMP + 300,
                'num' => $num,
                'ids' => $ids
            ), true);
        }

        $index = C::t('common_searchindex')->fetch_by_searchid_srchmod($searchid, 2);
        if (!$index) {
            return array();
        }
        $tids = explode(',', $index['ids']);
        $tids = array_diff($tids, array(0));
        $data = array();
        if (!empty($tids)) {
            $total = count($tids);
            $start = ($page - 1) * 10;
            $limit = 10;
            foreach(C::t('forum_thread')->fetch_all_by_tid_fid_displayorder(explode(',',$index['ids']), null, 0, 'lastpost', $start, $limit, '>=', 'DESC') as $thread) {
                $data[] = array(
                    'tid' => $thread['tid'],
                    'subject' => $thread['subject'],
                    'author' => $thread['author'],
                    'postdate' => $thread['dateline'],
                    'views' => $thread['views'],
                    'numFound' => $total,
                    'attachment' => $thread['attachment'] ? 1 : 0
                );
            }
        }

        return $data;
    }

    /**
     * 解析url,获取tid
     *
     * @param $url
     * @return int|mixed
     */
    public static function getTidByThreadurl($url) {
        $matchUrl = Yii::app()->params['thread_match'];
        $tid = 0;
        if( !empty($matchUrl) && is_int(strpos($matchUrl, '{ID}')) ) {
            $matchStr = explode('{ID}', $matchUrl);
            $tid = str_replace(array($matchStr[0], $matchStr[1]), '', $url);
        }
        return $tid;
    }

}

